/* SPSS Macro pro vcekriteriln ven
/* Autor: sedlo (www.mr-serv.com)

DATASET CLOSE ALL.
GET FILE = "C:\..path..\DATA_test_SPSS16.SAV".

/* promnn s vcm kritriem se mus pojmenovat ve tavru wpromenna
/* nap. pokud pohlav je q1, pak vc kritria pro pohlav se mus dt do promnn wq1 
/* hodnota ve vcch promnnch me bt v libovolnm formtu - v potu interview nebo ve formtu procent, dleit jsou relativn pomry
/* v podku je tohle zadn:
/*   IF (q1=1) wq1 = 200.
/*   IF (q1=2) wq1 = 300.
/* ale v podku je tak tohle zadn:
/*   IF (q1=1) wq1 = 0.4.
/*   IF (q1=2) wq1 = 0.6.

IF (q1=1) wq1 = 71.
IF (q1=2) wq1 = 29.

IF (q2=1) wq2 = 12.
IF (q2=2) wq2 = 22.
IF (q2=3) wq2 = 25.
IF (q2=4) wq2 = 22.
IF (q2=5) wq2 = 20.

IF (q3=1) wq3 = 11.
IF (q3=2) wq3 = 42.
IF (q3=3) wq3 = 34.
IF (q3=4) wq3 = 13.

IF (q4=1 ) wq4 = 11.863.
IF (q4=2 ) wq4 = 11.510.
IF (q4=3 ) wq4 =  6.092.
IF (q4=4 ) wq4 =  5.426.
IF (q4=5 ) wq4 =  2.969.
IF (q4=6 ) wq4 =  7.960.
IF (q4=7 ) wq4 =  4.154.
IF (q4=8 ) wq4 =  5.294.
IF (q4=9 ) wq4 =  4.897.
IF (q4=10) wq4 =  4.917.
IF (q4=11) wq4 = 10.985.
IF (q4=12) wq4 =  6.176.
IF (q4=13) wq4 =  5.699.
IF (q4=14) wq4 = 12.058.

IF (q5=1) wq5 = 17.096.
IF (q5=2) wq5 = 20.384.
IF (q5=3) wq5 = 18.610.
IF (q5=4) wq5 = 23.155.
IF (q5=5) wq5 = 20.755.

EXECUTE.


DEFINE !mac_weight (w_vars = !ENCLOSE('[',']') / N = !ENCLOSE('[',']') )

  WEIGHT OFF.
  COMPUTE weight=1.


/* uren universa (tj. konen ven celkov poet respondent)
/* bu je to skuten poet interview, nebo pi spoutn makra meme zadat poadovan celkov poet

  !IF (!N=!NULL) !THEN
    AGGREGATE
      /OUTFILE=* MODE=ADDVARIABLES OVERWRITE=YES
      /BREAK weight
      /total 'Universum' = SUM(weight).
  !ELSE
     COMPUTE total=!N.
  !IFEND


/* normovn podklad pro ven, aby souet vah ve vech vcch kritrich byl=1
/* to se vynsob universem a zsk se tak poadovan poet respondent v pslun skupin

  !DO !var !IN (!w_vars)
    !LET !w_mod = !CONCAT("w_mod_",!var)
    !LET !ww_mod = !CONCAT("ww_mod_",!var)
    !LET !w = !CONCAT("w",!var)
    SORT CASES BY !var.
    COMPUTE !w_mod = !w.
    IF (!var=LAG(!var)) !w_mod = LAG(!w_mod).
    IF (!var<>LAG(!var)) !w_mod = SUM(LAG(!w_mod),!w).
    AGGREGATE
      /OUTFILE=* MODE=ADDVARIABLES OVERWRITE=YES 
      /BREAK = total
      /!ww_mod = MAX(!w_mod).
    COMPUTE !w_mod = total * !w / !ww_mod.
  !DOEND


/* ven - pot se postupn pro kad vic kritrium
/* setou se vhy v jednotlivch kritrich a tm se spot, kolik tam ven je kejs u jednotlivch kritri 
/* pak se to porovn s tm kolik jich tam podle zadn m bt a podle toho se uprav vha
/* pro dal zpesnn vhy bude cyklus iterovat tolikrt, kolik je promnnch

  !DO !iterate !IN (!w_vars)
    !DO !var !IN (!w_vars)
      !LET !w_mod = !CONCAT("w_mod_",!var)
      AGGREGATE
        /OUTFILE=* MODE=ADDVARIABLES OVERWRITE=YES 
        /BREAK = !var
        /number_of_resp = SUM(weight).
      COMPUTE weight = weight * (!w_mod / number_of_resp).
    !DOEND
  !DOEND


/* mazn pomocnch promnnch

  EXECUTE.
  !DO !var !IN (!w_vars)
    DELETE VARIABLES !CONCAT("w_mod_",!var).
  !DOEND
  DELETE VARIABLES number_of_resp.

  DESCRIPTIVES weight.
  WEIGHT BY weight.

!ENDDEFINE.

!mac_weight w_vars [wq1 wq2 wq3 wq4 wq5].
